﻿//デバッグ用
var DBG_PRT = false;

//変数の宣言
var idx = 0;//┬プログラムの進行を管理
var tmr = 0;//┘
var dcnt = 0;//描画(主にアニメーション)用のカウンター

//プレイヤーキャラの移動用
var XP = [  0,  0, -1,  1 ];//各向き（上下左右）の座標変化値
var YP = [ -1,  1,  0,  0 ];
var NPC_TALK_DIR = [ 1, 0, 3, 2 ];//会話時にＮＰＣをプレイヤーに向かせる
var PLWF = 4;//何フレームで１マス動くか
var plWalk = 0;//移動処理のフラグ（カウンター）
var map_no = 0;//プレイヤーがどのマップにいるか
var worldX, worldY;//プレイヤーのワールドマップ上の座標（町やダンジョンの出入りで使用）

//マップデータの管理
var mapdata = [];
var mapname = "";
var mapW, mapH;
var mapAtt = [ 0, 0, 0, 0, 0 ];//マップの属性　範囲外は何番のチップにするかなど
var bgmBak = -1;//それまで流していたＢＧＭの番号

function setMap() {//マップデータをセットする
 var mtop = 0;
 var loop = 0;
 while( true ) {//データの頭出し
  mapname = MAPDATA[mtop];
  mapW = MAPDATA[mtop+1];
  mapH = MAPDATA[mtop+2];
  if( loop == map_no ) break;
  loop ++;
  mtop = mtop + 8 + mapW*mapH;
 }
 for( var i = 0; i < mapW*mapH; i ++ ) mapdata[i] = MAPDATA[mtop+3+i];
 for( var i = 0; i < 5; i ++ ) mapAtt[i] = MAPDATA[mtop+3+mapW*mapH+i];
 if( bgmBak != mapAtt[1] ) {//ＢＧＭの番号が変化した場合
  bgmBak = mapAtt[1];
  if( mapAtt[1] >= 0 ) playBgm(mapAtt[1]); else stopBgm();//出力もしくは停止
 }
}

function chipNo( x, y ) {//マップチップの値を返す
 if( x < 0 || x >= mapW || y < 0 || y >= mapH ) return mapAtt[0];
 return mapdata[x+y*mapW];
}

function drawChip( cn, dx, dy ) {//マップチップを表示
 var sx = 1+(CHIP_SIZE+2)*(cn%10);
 var sy = 1+(CHIP_SIZE+2)*(toInt(cn/10));
 drawImgTS( 0, sx, sy, CHIP_SIZE, CHIP_SIZE, dx, dy, CHIP_SIZE, CHIP_SIZE );
}

//オブジェクトの管理
var OBJ_MAX = 100;//最大いくつのオブジェを管理するか			【開発メモ】0～9の10個はパーティメンバー用
var objMax;//各マップに配置されたオブジェの数					【開発メモ】マップシンボルやNPCは配列10番から配置する
var objNum;//プレイヤーが載った（接した）オブジェクト番号
var objType = [];//タイプ　マップシンボルなのか人間なのかなど	【開発メモ】値は ohq_mapdata.js で定義している
var objX = [], objY = [];//マップチップ上の座標
var objCX = [], objCY = [];//キャンバスに表示するための座標
var objP = [], objW = [], objH = [];//絵の番号、サイズ
var objD1 = [], objD2 = [], objD3 = [], objD4 = [];//各種のデータ【開発メモ】プレイヤーキャラとＮＰＣの向きは objD1 で管理

function initPty() {//パーティメンバーの変数の初期値
 objX[0] = 10;
 objY[0] = 10;
 objCX[0] = objX[0]*CHIP_SIZE;
 objCY[0] = objY[0]*CHIP_SIZE;
 objP[0] = IMG_HUMAN;
 objD1[0] = 1;//向き　0上,1下,2左,3右
 map_no = 0;
 plWalk = 0;
}

function initObj() {//オブジェクト用変数の初期化
 for( var i = 0; i < OBJ_MAX; i ++ ) {
  objType[i] = 0;
  objX[i] = 0; objY[i] = 0;
  objCX[i] = 0; objCY[i] = 0;
  objP[i] = 0; objW[i] = 0; objH[i] = 0;
  objD1[i] = 0; objD2[i] = 0; objD3[i] = 0; objD4[i] = 0;
 }
 objType[0] = OBJ_PTY;//★★★開発中　プレイヤーが動かすキャラ
}

function clrObj() {//オブジェクトが配置されていない状態にする
 for( var i = 10; i < OBJ_MAX; i ++ ) objType[i] = 0;//※この値が0なら存在しないものとする
}

function setObj() {//オブジェクトデータをセットする
 var pos = 0;
 var loop = 0;
 while( true ) {//データの頭出し
  if( isNaN(OBJDATA[pos]) == true ) {
   if( loop == map_no ) break;
   loop ++;
  }
  pos ++;
 }
 pos ++
 objMax = 10;
 while( true ) {
  if( isNaN(OBJDATA[pos]) == true ) break;
console.log("オブジェ配置"+objMax+":"+pos);//★★★デバッグ
  objType[objMax]  = OBJDATA[pos+0];
  objP[objMax]  = OBJDATA[pos+1];
  objX[objMax]  = OBJDATA[pos+2];
  objY[objMax]  = OBJDATA[pos+3];
  objCX[objMax] = objX[objMax]*CHIP_SIZE;
  objCY[objMax] = objY[objMax]*CHIP_SIZE;
  objD1[objMax] = OBJDATA[pos+4];
  objD2[objMax] = OBJDATA[pos+5];
  objD3[objMax] = OBJDATA[pos+6];
  objD4[objMax] = OBJDATA[pos+7];
  pos += 10;
  objMax ++;
 }
}

function chkSw() {//プレイヤーのいる場所にスイッチがあるか？
 var ret = -1;
 for( var i = 10; i < objMax; i ++ ) {
  if( objType[i] == OBJ_SW && objX[i] == objX[0] && objY[i] == objY[0] ) { ret = i; break; }
 }
 return ret;
}

function chkObj( dir ) {//プレイヤーの目の前にオブジェクトがあるか？
 var ret = -1;
 for( var i = 10; i < objMax; i ++ ) {
//【開発中】現状ＮＰＣだけ判定
  if( objType[i] == OBJ_NPC && objX[i] == objX[0]+XP[dir] && objY[i] == objY[0]+YP[dir] ) { ret = i; break; }
 }
 return ret;
}

function drawChr( cn, dx, dy, dir ) {//キャラクターの表示
 var sx = 48*(toInt(dcnt/4)%2);
 var sy = 72*dir;
 drawImgTS( cn, sx, sy, 48, 72, dx, dy, 48, 72 );
}

function drawObj() {//オブジェクトを描画する
 var i, j, n, x, y;
 //表示順番をソート処理で決める
 var sortN = [], sortY = [];
 for( i = 0; i < objMax; i ++ ) {
  sortN[i] = i;
  sortY[i] = objCY[i];
  if( objType[i] == OBJ_SW ) sortY[i] -= 1000;//スイッチは強制的に“下側”に表示
 }
 for( i = 0; i < objMax-1; i ++ ) {//バブルソートで並び替える
  for( j = 0; j < objMax-1-i; j ++ ) {
   if( sortY[j] > sortY[j+1] ) {
    n = sortN[j]; sortN[j] = sortN[j+1]; sortN[j+1] = n;
    y = sortY[j]; sortY[j] = sortY[j+1]; sortY[j+1] = y;
   }
  }
 }

 for( i = 0; i < objMax; i ++ ) {//表示処理
  n = sortN[i];
  if( objType[n] == 0 ) continue;
  x = objCX[n]-objCX[0]+(7*CHIP_SIZE);//プレイヤーキャラとの相対座標
  y = objCY[n]-objCY[0]+(7*CHIP_SIZE);
  if( objType[n] == OBJ_PTY || objType[n] == OBJ_NPC ) {
   y -= 32;//足元の位置
   if( -96 < x && x < 720 && -96 < y && y < 720 ) drawChr( objP[n], x, y, objD1[n] );
  }
  if( objType[n] == OBJ_SW ) {
   x -= ( MAPSYMBOL_W[objP[n]-IMG_MAPSYMBOL]-CHIP_SIZE )/2;//画像のセンタリング
   y -= ( MAPSYMBOL_H[objP[n]-IMG_MAPSYMBOL]-CHIP_SIZE )/2;
   if( -96 < x && x < 720 && -96 < y && y < 720 ) drawImg( objP[n], x, y );
  }
 }
}

//マップ（ＢＧ）の描画
var mapL, mapT, ofsX, ofsY;
function drawBG() {
 var x, y;
 mapL = toInt(objCX[0]/CHIP_SIZE)-7;
 mapT = toInt(objCY[0]/CHIP_SIZE)-7;
 ofsX = -(objCX[0]%CHIP_SIZE);
 ofsY = -(objCY[0]%CHIP_SIZE);
 for( y = -1; y < 16; y ++ ) {
  for( x = -1; x < 16; x ++ ) drawChip( chipNo(mapL+x,mapT+y), x*CHIP_SIZE+ofsX, y*CHIP_SIZE+ofsY );
 }
}

//ヴァーチャルキーの表示と入力判定
var vkey = 0;
function virtualKey() {
 vkey = 0;
 if( winW > winH ) {
  fRect( 720, 0, 240, 720, "gray" );
  drawBtn( "↑", 840,  90, 240-2, 180-2, 32, "white", 0 ); if( btn_on[0] > 0 ) vkey = 38;
  drawBtn( "↓", 840, 630, 240-2, 180-2, 32, "white", 1 ); if( btn_on[1] > 0 ) vkey = 40;
  drawBtn( "←", 780, 360, 120-2, 360-2, 32, "white", 2 ); if( btn_on[2] > 0 ) vkey = 37;
  drawBtn( "→", 900, 360, 120-2, 360-2, 32, "white", 3 ); if( btn_on[3] > 0 ) vkey = 39;
  drawCBtn( "SPC", 640, 640, 60, 32, "white", 4 ); if( btn_on[4] == 1 ) vkey = 32;
  drawBtn( "[S]ound " + (SOUND_ON?"OFF":"ON"), 640, 60, 144, 48, 20, "cyan", 5 ); if( btn_on[5] == 1 ) vkey = 83;
 }
 else {
  fRect( 0, 720, 720, 240, "black" );
  drawBtn( "↑", 360, 780, 360-2, 120-2, 32, "white", 0 ); if( btn_on[0] > 0 ) vkey = 38;
  drawBtn( "↓", 360, 900, 360-2, 120-2, 32, "white", 1 ); if( btn_on[1] > 0 ) vkey = 40;
  drawBtn( "←",  90, 840, 180-2, 240-2, 32, "white", 2 ); if( btn_on[2] > 0 ) vkey = 37;
  drawBtn( "→", 630, 840, 180-2, 240-2, 32, "white", 3 ); if( btn_on[3] > 0 ) vkey = 39;
  drawCBtn( "SPC", 360, 640, 60, 32, "white", 4 ); if( btn_on[4] == 1 ) vkey = 32;
  drawBtn( "[S]ound " + (SOUND_ON?"OFF":"ON"), 640, 60, 144, 48, 20, "cyan", 5 ); if( btn_on[5] == 1 ) vkey = 83;
 }
}

//ブラウザのサイズが変化した時（スマホなら縦持ち⇔横持ち）
//CWIDTH,CHEIGHT,SCALE,winW,winH変数はシステムで定義されている
function resizeCanvas() {
 var cw, ch;
 if( winW < winH ) {//縦長の画面
  CWIDTH = 720;
  CHEIGHT = 960;
  cw = winW;
  ch = winW*CHEIGHT/CWIDTH;
  if( winW/winH > CWIDTH/CHEIGHT ) {//縦長ではあるが（正方形に近く）上２行の値では高さが入らない場合
   ch = winH;
   cw = winH*CWIDTH/CHEIGHT;
  }
 }
 else {
  CWIDTH = 960;
  CHEIGHT = 720;
  cw = winH*CWIDTH/CHEIGHT;
  ch = winH;
  if( winW/winH < CWIDTH/CHEIGHT ) {//横長ではあるが（正方形に近く）上２行の値では幅が入らない場合
   cw = winW;
   ch = winW*CHEIGHT/CWIDTH;
  }
 }
 cw = toInt(cw);
 ch = toInt(ch);
 SCALE = cw / CWIDTH;
 canvas.width = cw;
 canvas.height = ch;
 bg.scale(SCALE,SCALE);
 bg.textAlign = "center";
 bg.textBaseline = "middle";
}

//メイン処理　※メインループはWWSシステムが担っている
function mainProc() {
 var i, x, y, w, h;
 tmr ++;
 dcnt ++;

 switch( idx ) {
  case 0://初期化処理
  resizeCanvas();
  initObj();
  initPty();
  setMap();
  setObj();
  idx = 1;
  break;

  case 1://プレイヤーキャラの移動
  drawBG();
  drawObj();
  virtualKey();
  if( plWalk == 0 ) {//停止中
   objCX[0] = objX[0]*CHIP_SIZE;
   objCY[0] = objY[0]*CHIP_SIZE;
   objNum = chkSw();
   if( objNum >= 10 ) {//町やダンジョンに入る
    idx = 2;
    tmr = 0;
    break;
   }
   if( objX[0] < 0 || objX[0] >= mapW || objY[0] < 0 || objY[0] >= mapH ) {//ワールドマップに戻る
    idx = 2;
    tmr = 0;
    break;
   }

if( key[83] == 1 || vkey == 83 ) {//★★★サウンド仮実装
 if( SOUND_ON == false ) {
  SOUND_ON = true;
  if( mapAtt[1] >= 0 ) playBgm(mapAtt[1]);
 }
 else {
  SOUND_ON = false;
  stopBgm();
 }
}

   if(      inkey == 38 || vkey == 38 ) { objD1[0] = 0; if( WALL[ chipNo(objX[0],objY[0]-1) ] == 0 && chkObj(objD1[0]) == -1 ) { objY[0] --; plWalk = 1; } }
   else if( inkey == 40 || vkey == 40 ) { objD1[0] = 1; if( WALL[ chipNo(objX[0],objY[0]+1) ] == 0 && chkObj(objD1[0]) == -1 ) { objY[0] ++; plWalk = 1; } }
   else if( inkey == 37 || vkey == 37 ) { objD1[0] = 2; if( WALL[ chipNo(objX[0]-1,objY[0]) ] == 0 && chkObj(objD1[0]) == -1 ) { objX[0] --; plWalk = 1; } }
   else if( inkey == 39 || vkey == 39 ) { objD1[0] = 3; if( WALL[ chipNo(objX[0]+1,objY[0]) ] == 0 && chkObj(objD1[0]) == -1 ) { objX[0] ++; plWalk = 1; } }
   else if( key[32] == 1 || vkey == 32 ) {//【制作中】調べる
    objNum = chkObj(objD1[0]);
    if( objNum >= 10 ) {//目の前にＮＰＣがいる
     objD1[objNum] = NPC_TALK_DIR[objD1[0]];//プレイヤーの方に向かせる
     idx = 3;
     break;
    }
   }
  }
  else {//移動中
   objCX[0] = (objX[0]-XP[objD1[0]])*CHIP_SIZE + XP[objD1[0]]*CHIP_SIZE*plWalk/PLWF;
   objCY[0] = (objY[0]-YP[objD1[0]])*CHIP_SIZE + YP[objD1[0]]*CHIP_SIZE*plWalk/PLWF;
   plWalk ++;
   if( plWalk >= PLWF ) plWalk = 0;
  }
  break;

  case 2://マップ切り替え
  drawBG();
  drawObj();
  virtualKey();
  if( tmr == 1 ) {
   if( map_no == 0 ) { worldX = objX[0]; worldY = objY[0]; }
  }
  if( tmr <= 20 ) fRect( 0, 0, CHIP_SIZE*15, CHIP_SIZE*15, "rgba(0,0,0,"+0.05*tmr+")" );
  if( tmr >  20 ) fRect( 0, 0, CHIP_SIZE*15, CHIP_SIZE*15, "rgba(0,0,0,"+0.05*(40-tmr)+")" );
  if( tmr == 20 ) {
   if( map_no > 0 ) {//ワールドマップに戻る
    objX[0] = worldX;
    objY[0] = worldY+1;
    objD1[0] = 1;
    map_no = 0;
   }
   else {//町やダンジョンに入る
    map_no = objD1[objNum];
    objX[0] = objD2[objNum];
    objY[0] = objD3[objNum];
    objD1[0] = objD4[objNum];
   }
   objCX[0] = objX[0]*CHIP_SIZE;
   objCY[0] = objY[0]*CHIP_SIZE;
   clrObj();
   setObj();
   setMap();
  }
  if( tmr == 40 ) idx = 1;
  break;

  case 3://会話
  drawBG();
  drawObj();
  virtualKey();
  x = 360;
  y = 480;
  w = 640;
  h = 120;
  fRect( x-w/2, y-h/2, w, h, "rgba(0,0,0,0.5)" );
  sRect( x-w/2, y-h/2, w, h, "white" );
  fText( TALK_DATA[objD2[objNum]], x, y, 32, "white" );
  if( key[32] == 1 || vkey == 32 ) idx = 1;
  break;

 }

 fText( mapname, 100, 30, 24, "white" );
 fText( ""+idx+":"+tmr, 100, 60, 24, "cyan" );
 fText( "X="+objX[0]+" Y="+objY[0]+" D="+objD1[0]+" map_no="+map_no, 400, 30, 24, "white" );
if( DBG_PRT ) {//★★★デバッグ
 fText( "CX="+objCX[0]+" CY="+objCY[0]+" plWalk="+plWalk, 400, 60, 24, "white" );
 fText( "bgmBak="+bgmBak+" BGM番号="+mapAtt[1], 400, 90, 24, "cyan" );
 fText( "objType[0]="+objType[0], 400, 120, 24, "black" );
 fText( "inkey="+inkey+" vkey="+vkey, 400, 150, 24, "green" );
 fText( "key[32]="+key[32]+" btn_on[4]="+btn_on[4], 400, 180, 24, "pink" );
 if( plWalk == 0 ) fText( chkObj(), 680, 30, 24, "yellow" );
}

 //ブラウザのサイズが変化したか？（スマホなら持ち方を変えたか　縦持ち⇔横持ち）
 w = window.innerWidth;
 h = window.innerHeight;
 if( winW != w || winH != h ) {
  winW = w;
  winH = h;
  resizeCanvas();
 }

}

//【メモ】メイン処理と描画処理を分ける場合、描画処理をここに記載
function drawProc() {}
